#!/usr/bin/perl -w
use LWP::UserAgent;
+use LWP::ConnCache;
use XML::Simple;
use Data::Dumper;
use MIME::Base64;
use Digest::MD5 qw(md5);
-my $ua = LWP::UserAgent->new;
-my $sid;
-my $host;
+my $ua = LWP::UserAgent->new(cookie_jar => {});
+my $url;
my $poweronms=200;
my $poweroffms=5000;
my $verbose = 0;
sub _hash {
my ($password, $challenge) = @_;
my @challenge_bytes = unpack 'c16', decode_base64($challenge);
- my @pwd_hash = unpack 'c16', md5($password);
+ my @pwd_hash = unpack 'c16', md5($password);
my @xor_bytes;
for my $i (0..15) {
$xor_bytes[$i] = $challenge_bytes[$i] ^ $pwd_hash[$i];
sub _req {
my $xml = shift;
- $request = HTTP::Request->new(POST => "http://${host}/cgi/bin");
- $request->header(Cookie => "sid=$sid");
+ $request = HTTP::Request->new(POST => "${url}/cgi/bin");
$request->content_type('application/x-www-form-urlencoded');
- $request->content($xml);
+ $request->content('<?XML version="1.0"?><?RMCXML version="1.0"?><RMCSEQ>'.$xml.'</RMCSEQ>');
$response = $ua->request($request);
die("Error in request: " . $response->status_line . "\n") unless ($response->is_success);
- XMLin($response->content);
+ XMLin($response->content, SuppressEmpty => '')->{RESP};
+}
+
+sub _cmd {
+ my $cmd = shift;
+
+ my $reqstr='<REQ CMD="'.$cmd.'"></REQ>';
+ my $res = _req($reqstr);
+ if ($res->{RC} ne '0x0') {
+ print "${cmd} failed: ".$res->{RC}."\n";
+ undef;
+ }
+
+ $res;
}
sub _getprop {
my $property = shift;
- my $reqstr='<?xml version="1.0"?><?RMCXML version="1.0"?><RMCSEQ><REQ CMD="propget"><PROPLIST><PROP NAME="'.$property.'"/></PROPLIST></REQ></RMCSEQ>';
+ my $reqstr='<REQ CMD="propget"><PROPLIST><PROP NAME="'.$property.'"/></PROPLIST></REQ>';
my $resp = _req($reqstr);
print "get: ${property}\n" if ($verbose);
- if ($resp->{RESP}->{RC} ne '0x0') {
- $resp->{RESP}->{RC};
+ if ($resp->{RC} ne '0x0') {
+ $resp->{RC};
} else {
$resp;
}
sub logout {
print "Logout\n" if ($verbose);
- my $request = HTTP::Request->new(GET => "http://${host}/cgi/logout");
- $request->header(Cookie => "sid=$sid");
+ my $request = HTTP::Request->new(GET => "${url}/cgi/logout");
my $response = $ua->request($request);
die("While trying to logout: " . $response->status_line . "\n") unless ($response->is_success);
my $property = shift;
my $value = shift;
- my $oldval = _getprop($property)->{RESP}->{PROPLIST}->{PROP}->{VAL};
+ my $oldval = _getprop($property)->{PROPLIST}->{PROP}->{VAL};
if ($value eq $oldval) {
print "${property} is already ${value}\n" if ($verbose);
return;
}
- my $reqstr='<?xml version="1.0"?><?RMCXML version="1.0"?><RMCSEQ><REQ CMD="propset"><PROP NAME="'.$property.'"><VAL>'.$value.'</VAL></PROP></REQ></RMCSEQ>';
+ my $reqstr='<REQ CMD="propset"><PROP NAME="'.$property.'"><VAL>'.$value.'</VAL></PROP></REQ>';
my $res = _req($reqstr);
- if ($res->{RESP}->{RC} ne '0x0') {
- print "Error setting ${property} to ${value}: ".$res->{RESP}->{RC}."\n";
+ if ($res->{RC} ne '0x0') {
+ print "Error setting ${property} to ${value}: ".$res->{RC}."\n";
undef;
} else {
print "${property}: ${oldval} -> ${value}\n" if ($verbose);
setprop("SERVER_POWER_OFF_MODE", sprintf("0x%x", $pmode));
print "${action}...\n" if ($verbose);
- my $reqstr='<?xml version="1.0"?><?RMCXML version="1.0"?><RMCSEQ><REQ CMD="serveraction"><ACT>'.$action.'</ACT></REQ></RMCSEQ>';
+ my $reqstr='<REQ CMD="serveraction"><ACT>'.$action.'</ACT></REQ>';
my $res = _req($reqstr);
- if ($res->{RESP}->{RC} ne '0x0') {
- print "FAILED:".$res->{RESP}->{RC}."\n";
+ if ($res->{RC} ne '0x0') {
+ print "FAILED:".$res->{RC}."\n";
}
}
sub showprop {
my $property = shift;
- my $phash = _getprop($property)->{RESP}->{PROPLIST}->{PROP};
+ my $phash = _getprop($property)->{PROPLIST}->{PROP};
print "${property}: " . ${phash}->{VAL} . " (" . ${phash}->{PERMS} . ")\n";
}
sub board_properties {
- my $reqstr='<?xml version="1.0"?><?RMCXML version="1.0"?><RMCSEQ><REQ CMD="boardpropget"><PROPLIST><PROP NAME=""/></PROPLIST></REQ></RMCSEQ>';
+ my $reqstr='<REQ CMD="boardpropget"><PROPLIST><PROP NAME=""/></PROPLIST></REQ>';
my $resp = _req($reqstr);
print " * Board Properties:\n";
- foreach my $bprop (@{$resp->{RESP}->{BPROPLIST}->{BPROP}}) {
+ foreach my $bprop (@{$resp->{BPROPLIST}->{BPROP}}) {
print " * " . ${bprop}->{NAME} . ": " . ${bprop}->{VAL} . "\n";
}
}
sub show_boarddesc {
- my $reqstr='<?xml version="1.0"?><?RMCXML version="1.0"?><RMCSEQ><REQ CMD="boardpropget"><BPROPLIST><BPROP NAME="BOARD_DESCRIPTION"/></BPROPLIST></REQ></RMCSEQ>';
- my $boarddesc64 = _req($reqstr)->{RESP}->{BPROPLIST}->{BPROP}->{VAL};
+ my $reqstr='<REQ CMD="boardpropget"><BPROPLIST><BPROP NAME="BOARD_DESCRIPTION"/></BPROPLIST></REQ>';
+ my $boarddesc64 = _req($reqstr)->{BPROPLIST}->{BPROP}->{VAL};
my $boarddesc = decode_base64($boarddesc64);
my @board = split(//, $boarddesc);
foreach my $byte (@board) {
printf ("0x%02x ", ord($byte));
-}
-print "\n";
+ }
+ print "\n";
}
sub show_all_vars {
}
}
+sub usrlist {
+ my $res = _cmd("usrlist");
+ my @users = ();
+
+ if ($res->{RC} ne '0x0') {
+ print "FAILED:".$res->{RC}."\n";
+ ();
+ } else {
+ if (ref($res->{USRLIST}->{USER}) eq 'ARRAY') {
+ foreach my $usr (@{$res->{USRLIST}->{USER}}) {
+ push @users, $usr->{NAME};
+ }
+ } else {
+ push @users, $res->{USRLIST}->{USER}->{NAME};
+ }
+ }
+ @users;
+}
+
+sub getusrprops {
+ my $usr = shift;
+
+ my $reqstr = '<REQ CMD="usrpropget"><USER NAME="'.$usr.'"></USER></REQ>';
+ my $res = _req($reqstr)->{USER}->{PROP};
+
+ $res;
+}
+
+sub usradd {
+ my $usr = shift;
+
+ my $reqstr='<REQ CMD="usradd"><USER NAME="'.$usr.'"/></REQ>';
+ my $res = _req($reqstr);
+ if ($res->{RC} ne '0x0') {
+ print "FAILED:".$res->{RC}."\n";
+ }
+}
+
+sub setusrprop {
+ my $usr = shift;
+ my $property = shift;
+ my $value = shift;
+
+ my $reqstr='<REQ CMD="usrpropget"><USER NAME="'.$usr.'"><PROP NAME="'.$property.'"></PROP></USER></REQ>';
+ my $res = _req($reqstr);
+
+ my $oldval = ${res}->{USER}->{PROP}->{VAL};
+
+ if ($value eq $oldval) {
+ print "${property} is already ${value}\n" if ($verbose);
+ return;
+ }
+
+ $reqstr='<REQ CMD="usrpropset"><USER NAME="'.$usr.'"><PROP NAME="'.$property.'"><VAL>'.$value.'</VAL></PROP></USER></REQ>';
+ $res = _req($reqstr);
+
+ if ($res->{RC} ne '0x0') {
+ print "Error setting ${property} to ${value}: ".$res->{RC}."\n";
+ undef;
+ } else {
+ print "${property}: ${oldval} -> ${value}\n" if ($verbose);
+ $oldval;
+ }
+}
+
sub syslog_debug {
my $destination_ip = shift;
my $bcast = shift;
- $reqstr='<?xml version="1.0"?><?RMCXML version="1.0"?><RMCSEQ><REQ CMD="dbgmsglancfg"><IP>'.${destination_ip}.'</IP><BCAST>'.${bcast}.'</BCAST><STORE>FALSE</STORE></REQ></RMCSEQ>';
- $res = _req($reqstr);
- if ($res->{RESP}->{RC} ne '0x0') {
- print "FAILED:".$res->{RESP}->{RC}."\n";
+ my $reqstr='<REQ CMD="dbgmsglancfg"><IP>'.${destination_ip}.'</IP><BCAST>'.${bcast}.'</BCAST><STORE>FALSE</STORE></REQ>';
+ my $res = _req($reqstr);
+ if ($res->{RC} ne '0x0') {
+ print "FAILED:".$res->{RC}."\n";
return;
}
- $reqstr='<?XML version="1.0"?><?RMCXML version="1.0"?><RMCSEQ><REQ CMD="dbgmsgcfg"><ON>TRUE</ON><CHANNELMASK>0x1</CHANNELMASK><MMASK>0x1</MMASK><STORE>FALSE</STORE></REQ></RMCSEQ>';
+ $reqstr='<REQ CMD="dbgmsgcfg"><ON>TRUE</ON><CHANNELMASK>0x1</CHANNELMASK><MMASK>0x1</MMASK><STORE>FALSE</STORE></REQ>';
$res = _req($reqstr);
- if ($res->{RESP}->{RC} ne '0x0') {
- print "FAILED:".$res->{RESP}->{RC}."\n";
+ if ($res->{RC} ne '0x0') {
+ print "FAILED:".$res->{RC}."\n";
return;
}
print "Debug messages will be sent to ${destination_ip} (broadcast: ${bcast})\n";
}
+sub get_sensors {
+ my $slist= _cmd("sensorlist");
+ my @sensors;
+
+ if ($slist->{RC} ne '0x0') {
+ print "Error getting sensorlist: ".$slist->{RC}."\n";
+ return;
+ }
+
+ my $req = '<REQ CMD="sensorpropget"><HANDLE>'.$slist->{HANDLE}.'</HANDLE><SENSORLIST>';
+ foreach my $s (@{$slist->{SENSORLIST}->{SENSOR}}) {
+ $req .= '<SENSOR KEY="'.$s->{KEY}.'"/>';
+ }
+ $req .= '</SENSORLIST></REQ>';
+
+ my $sprop = _req($req);
+ foreach my $s (@{$sprop->{SENSORLIST}->{SENSOR}}) {
+ my $sensor = {};
+ foreach my $sp (@{$s->{PROP}}) {
+ $sensor->{$sp->{NAME}} = $sp->{VAL};
+ }
+
+ next if (!defined($sensor->{NAME}));
+ $sensor->{VAL} = '0' if ($sensor->{VAL} eq '');
+ push @sensors, $sensor;
+ }
+ @sensors;
+}
+
+sub show_sensors {
+ my @sensors = get_sensors();
+
+ foreach my $sensor (@sensors) {
+ print $sensor->{NAME}.": ".$sensor->{VAL}.$sensor->{UNITS};
+
+ my @info = ();
+ foreach my $field qw(MIN MAX LOW_NON_CRITICAL UPPER_NON_CRITICAL LOW_CRITICAL UPPER_CRITICAL) {
+ if ($sensor->{$field} ne '') {
+ push @info, "${field}: ".$sensor->{$field}.$sensor->{UNITS};
+ }
+ }
+
+ print "\t(".join(", ",@info).")" if (@info);
+
+ print "\n";
+ }
+}
+
+sub status {
+ my $boardstatus = _cmd("boardstatus")->{STATUS};
+ my $fw = _cmd("boardfwstatus");
+ my $boardfwstatus = $fw->{STATUS};
+ my $boardfwprogress = $fw->{PROGRESS};
+ $bs = hex($boardstatus);
+
+ print "Server Power:\t\t" . (($bs & 0x01) ? "ON" : "OFF") . "\n";
+ print "External PSU:\t\t" . (($bs & 0x02) ? "ON" : "OFF") . "\n";
+ print "Battery:\t\t";
+ if ($bs & 0x04) {
+ if ($bs & 0x08) {
+ print "LOW\n";
+ } elsif ($bs & 0x800) {
+ print "ON\n";
+ } else {
+ print "UNKNOWN\n";
+ }
+ } else {
+ print "OFF\n";
+ }
+ print "Standby Power:\t\t" . (($bs & 0x08) ? "ON" : "OFF") . "\n";
+ print "LAN:\t\t\t" . (($bs & 0x10) ? "CONNECTED" : "NC") . "\n";
+ print "I2C:\t\t\t" . (($bs & 0x20) ? "CONNECTED" : "NC") . "\n";
+ print "SMM:\t\t\t" . (($bs & 0x40) ? "CONNECTED" : "NC") . "\n";
+ print "Instrumentation:\t" . (($bs & 0x200) ? "CONNECTED" : "NC") . "\n";
+ print "ICMB:\t\t\t" . (($bs & 0x400) ? "CONNECTED" : "NC") . "\n";
+ print "PPP:\t\t\t" . (($bs & 0x10000) ? "ON" : "OFF") . "\n";
+ print "Paging:\t\t\t" . (($bs & 0x20000) ? "ON" : "OFF") . "\n";
+ print "COM redirection:\t" . (($bs & 0x100000) ? "ON" : "OFF") . "\n";
+ print "UART redirect:\t\t" . (($bs & 0x200000) ? "ON" : "OFF") . "\n";
+ print "UART redirect pending:\t" . (($bs & 0x400000) ? "TRUE" : "FALSE") . "\n";
+ print "Hex BoardStatus:\t${boardstatus}\n";
+ my $fws = hex ($boardfwstatus);
+ print "FW status:\t\t";
+ if ($fws == 3 || $fws == 32771) {
+ print "WAITING";
+ } else {
+ print "DONE";
+ }
+ print " (${boardfwstatus})\n";
+ if (($fws & 0x8080) || ($fws & 0x80)) {
+ printf("FW error:\t\t0x%02x\n", ($fws & 0xff));
+ }
+ if ($fws != 0) {
+ print "FW upgrade progress:\t${boardfwprogress}\n";
+ }
+ print "\nSensors:\n";
+ show_sensors();
+}
+
+sub spawn_gui {
+ my $base = shift;
+ open(APPLET,"|appletviewer -J-Djava.security.policy=applet.policy /dev/stdin");
+ print APPLET '<HTML><HEAD><TITLE>RSB S2 User Interface</TITLE></HEAD>';
+ print APPLET '<BODY>';
+ print APPLET '<object width="640" height="480">';
+ print APPLET '<param name="code" value="com/agilent/rmc/mgui/RmcUI.class">';
+ print APPLET '<param name="codebase" value="'.$base.'/">';
+ print APPLET '<param name="archive" value="gui.jar, msa_shared.jar, msa_shared_comm.jar, msa_shared_oem.jar">';
+ print APPLET '</object>';
+ print APPLET '</BODY></HTML>';
+ close(APPLET);
+}
+
sub login {
my $user = shift;
my $pass = shift;
- my $response = $ua->get("http://${host}/cgi/challenge");
+ my $response = $ua->get("${url}/cgi/challenge");
die $response->status_line if (!($response->is_success));
my $xmlin = XMLin($response->decoded_content);
my $challenge = $xmlin->{CHALLENGE};
print "Challenge: ${challenge}\n" if ($verbose);
- $sid = $response->headers->header('Set-Cookie');
+ my $sid = $response->headers->header('Set-Cookie');
die "No SessionID!" if (!defined($sid));
chomp($sid);
$sid =~ s/.*sid=(.*);.*/$1/;
my $login_hash = _hash($pass, $challenge);
print "Hash: ${login_hash}\n" if ($verbose);
- my $request = HTTP::Request->new(GET => "http://${host}/cgi/login?user=${user}&hash=${login_hash}");
- $request->header(Cookie => "sid=$sid");
+ my $request = HTTP::Request->new(GET => "${url}/cgi/login?user=${user}&hash=${login_hash}");
$response = $ua->request($request);
die("While trying to login: " . $response->status_line . "\n") unless ($response->is_success);
$xmlin = XMLin($response->decoded_content);
die "Error logging in: ".$xmlin->{RC} if ($xmlin->{RC} ne '0x0');
- $sid;
+ print "Logged in\n" if ($verbose);
}
-open(INIFILE,"<$ENV{HOME}/.rsbs2rc") || die("can't open config: $ENV{HOME}/.rsbs2rc: $!");
-my %Config = ();
-my @sections = ();
-while(<INIFILE>) {
- chomp;
-
- next if (m/^#/);
-
- if (m/^\s*\[(.*)\]\s*$/) {
- push @sections, $1;
- next;
- }
+sub read_inifile {
+ my $filename = shift;
- if (@sections) {
- if (m/^\s*(.+)\s*=\s*(.*)\s*$/) {
- ${$Config{$sections[$#sections]}}{$1} = $2;
+ open(INIFILE,"<${filename}") || die("can't open config: ${filename}: $!");
+ my %Ini = ();
+ my @sections = ();
+ while(<INIFILE>) {
+ chomp;
+
+ next if (m/^#/);
+
+ if (m/^\s*\[(.*)\]\s*$/) {
+ push @sections, $1;
+ next;
+ }
+
+ if (@sections) {
+ if (m/^\s*([^=]+)\s*=\s*(.*)\s*$/) {
+ ${$Ini{$sections[$#sections]}}{$1} = $2;
+ }
}
}
+ close(INIFILE);
+
+ %Ini;
}
-close(INIFILE);
+
+my %Config = read_inifile("$ENV{HOME}/.rsbs2rc");
my $valid_arg = 0;
my $powup = 0;
my $powdown = 0;
my $powcyc = 0;
my $reset = 0;
+my $resetrsbs2 = 0;
my @sprop = ();
my @gprop = ();
+my @xmlsend = ();
my $show = 0;
my $enable_debug = "";
my $save = "";
my $load = "";
+my $showstat = 0;
+my $gui = 0;
my $hostalias;
while (defined($ARGV[0])) {
shift @ARGV;
last SWITCH;
};
+ /^-R$/ && do {
+ $resetrsbs2 = 1;
+ shift @ARGV;
+ last SWITCH;
+ };
/^-l$/ && do {
shift @ARGV;
$enable_debug = shift @ARGV;
shift @ARGV;
last SWITCH;
};
+ /^-X$/ && do {
+ shift @ARGV;
+ push @xmlsend, shift @ARGV;
+ last SWITCH;
+ };
+ /^-b$/ && do {
+ $showstat = 1;
+ shift @ARGV;
+ last SWITCH;
+ };
+ /^-G$/ && do {
+ $gui = 1;
+ shift @ARGV;
+ last SWITCH;
+ };
/^-save$/ && do {
shift @ARGV;
$save = shift @ARGV;
}
}
-if ($valid_arg && (!defined(${$Config{$hostalias}}{'host'}))) {
+if ($valid_arg && (!defined($Config{$hostalias}))) {
$valid_arg = 0;
}
print STDERR "\t-d\t\tpowerdown\n";
print STDERR "\t-c\t\tpowercycle\n";
print STDERR "\t-r\t\treset\n";
+ print STDERR "\t-R\t\treset RSB S2 board\n";
print STDERR "\t-x\t\tshow all properties, variables and settings\n";
print STDERR "\t-l IP\t\tsend SYSLOG debug messages to IP\n";
+ print STDERR "\t-b\t\tshow board/server status\n";
+ print STDERR "\t-X\t\tsend raw XML string (start with REQ tag)\n";
+ print STDERR "\t-G\t\tstart GUI in appletviewer\n";
print STDERR "\t-v\t\tverbose\n";
print STDERR "\t-save file\tsave configuration to 'file'\n";
print STDERR "\t-load file\tload configuration from 'file'\n";
print STDERR "\n";
print STDERR "card-alias\tone of: ";
- foreach my $alias (@sections) {
+ foreach my $alias (keys(%Config)) {
print STDERR "\"${alias}\" ";
}
print STDERR "(see ~/.rsbs2rc)\n";
exit(1);
}
-$host = ${$Config{$hostalias}}{"host"};
+my $host = ${$Config{$hostalias}}{"host"};
$poweronms = ${$Config{$hostalias}}{"poweronms"} if (defined(${$Config{$hostalias}}{"poweronms"}));
$poweroffms = ${$Config{$hostalias}}{"poweroffms"} if (defined(${$Config{$hostalias}}{"poweroffms"}));
-$sid = login(${$Config{$hostalias}}{"user"}, ${$Config{$hostalias}}{"pass"});
+my $ssl = ${$Config{$hostalias}}{"ssl"};
+my $port = ${$Config{$hostalias}}{"port"};
+
+if (defined($ssl) && (lc($ssl) eq 'yes')) {
+ $ENV{HTTPS_DEBUG} = 1;
+ $ENV{HTTPS_VERSION} = 3;
+ $port = 443 if (!defined($port));
+ $url = "https://${host}:${port}";
+} else {
+ $port = 80 if (!defined($port));
+ $url = "http://${host}:${port}";
+}
+
+if ($gui) {
+ spawn_gui($url);
+}
+
+login(${$Config{$hostalias}}{"user"}, ${$Config{$hostalias}}{"pass"});
if ($show) {
show_boarddesc();
}
}
+if (@xmlsend) {
+ foreach my $x (@xmlsend) {
+ $Data::Dumper::Terse = 1;
+ print Dumper(_req($x));
+ }
+}
+
if ($save ne '') {
my @dontsave = qw(ENABLE_LAN_AUTONEG ENABLE_LAN_100 ENABLE_LAN_FDUPLEX
GATEWAY IP_ADDRESS NETMASK TFTP_FIRMWARE_FILE TFTP_ADDR_FIRMWARE
- ENABLE_DHCP HELP_LOCATION HELP_LOCATION PPP_PORT PPP2_INIT PPP2_PORT
- SERVER_ID SNMP_SERVER_1 SNMP_SERVER_2 SNMP_SERVER_3 SNMP_SERVER_4
- SNMP_SERVER_5 SNMP_SERVER_6 SNMP_SERVER_7 SERVER_AD_NAME
- SERVER_AD_NAME2 SERVER_AD_NAME3 SERVER_AD_NAME4 SERVER_MAC_ADDRESS
- SERVER_MAC_ADDRESS2 SERVER_MAC_ADDRESS3 SERVER_MAC_ADDRESS4
- MAC_ADDRESS LAST_CARD_NAME LAST_ENABLE_DHCP LAST_GATEWAY
+ ENABLE_DHCP MAC_ADDRESS LAST_CARD_NAME LAST_ENABLE_DHCP LAST_GATEWAY
LAST_IP_ADDRESS LAST_NETMASK);
open (SAVEFILE, ">${save}") || die "Error opening save-file: $!\n";
+ print SAVEFILE "[global]\n";
print STDERR "saving" if (!$verbose);
foreach my $ts (@fw_vars) {
next if (grep(/^${ts}$/, @dontsave));
- my $phash = _getprop($ts)->{RESP}->{PROPLIST}->{PROP};
+ my $phash = _getprop($ts)->{PROPLIST}->{PROP};
next if ($phash->{PERMS} ne 'RW');
print SAVEFILE "${ts}=".$phash->{VAL}."\n";
print STDERR "." if (!$verbose);
}
+ foreach my $usr (usrlist()) {
+ print SAVEFILE "\n[${usr}]\n";
+ foreach my $up (@{getusrprops($usr)}) {
+ next if ($up->{PERMS} ne 'RW');
+
+ print SAVEFILE $up->{NAME}."=".$up->{VAL}."\n";
+ }
+ print STDERR "." if (!$verbose);
+ }
close(SAVEFILE);
print STDERR "done\n" if (!$verbose);
}
if ($load ne '') {
- open (LOADFILE, "<${load}") || die "Error opening load-file: $!\n";
+ my %loadfile = read_inifile("${load}");
print STDERR "loading" if (!$verbose);
- while(<LOADFILE>) {
- chomp;
- (my $p, my $v) = split(/=/, $_);
- setprop($p, $v);
+
+ foreach my $p (keys(%{$loadfile{'global'}})) {
+ setprop($p, $loadfile{'global'}->{$p});
print STDERR "." if (!$verbose);
}
- close(LOADFILE);
+
+ my @users = usrlist();
+ foreach my $usr (keys(%loadfile)) {
+ next if ($usr eq 'global');
+ if (!grep(/^${usr}$/, @users)) {
+ print STDERR "\nAdding user \"${usr}\".\n" if ($verbose);
+ usradd($usr);
+ }
+ foreach my $p (keys(%{$loadfile{$usr}})) {
+ setusrprop($usr, $p, $loadfile{$usr}->{$p});
+ print STDERR "." if (!$verbose);
+ }
+ }
print STDERR "done\n" if (!$verbose);
print "Settings loaded, resetting board...\n";
- my $reqstr='<?XML version="1.0"?><?RMCXML version="1.0"?><RMCSEQ><REQ CMD="boardreset"></REQ></RMCSEQ>';
- _req($reqstr);
+ _cmd("boardreset");
exit(0);
}
powercycle();
}
+if ($showstat) {
+ status();
+}
+
+if ($resetrsbs2) {
+ print "Resetting board...\n";
+ _cmd("boardreset");
+ exit(0);
+}
+
logout();